
/* ask_reliable_datagram_server.pde
 *  http://www.airspayce.com/mikem/arduino/RadioHead/examples.html
 *  modified J.Gálvez 12.03.21: * changed manager to RGDatagram.
 *                              ** LED added
 *                              *** settings changed -> now for ESP32
*/

#include <RHDatagram.h>                      //*
#include <RH_ASK.h>
 
#define CLIENT_ADDRESS 2
#define SERVER_ADDRESS 1                    //*
const int LedPin_G = 23;                    //**
 
// Singleton instance of the radio driver
//RH_ASK driver;
RH_ASK driver(2000, 4, 5, 0);               //*** ESP8266 or ESP32: do not use pin 11 or 2
 
// Class to manage message delivery and receipt, using the driver declared above
RHDatagram manager(driver, SERVER_ADDRESS); //*
 
void setup(){
  Serial.begin(230400);
  if (!manager.init())
    Serial.println("init failed");
    pinMode (LedPin_G, OUTPUT);             //**// Define the LED pin as output
}
 
//* uint8_t data[] = "And hello back to you";
// Dont put this on the stack:
uint8_t buf[10];
 
void loop(){
  if (manager.available()){
    // Wait for a message addressed to us from the client
    uint8_t len = sizeof(buf);
    uint8_t from;
    if (manager.recvfrom(buf, &len, &from)){       //* 
      Serial.print("got request from : 0x");
      Serial.print(from, HEX);
      Serial.print(": ");
      Serial.println((char*)buf);
      digitalWrite(LedPin_G, HIGH);               //**
      delay(50);                                  //**
    }
  }
  else {
      digitalWrite(LedPin_G, LOW);                //**
  }
}
 
